c===================================================
c Check input model for equal number of knots in
c each layer at all geographical point.
c===================================================
      subroutine lay_info
      implicit none
c --- Common block definitions ---
      integer*4 nlayers,npoints,mnn(43000),mind(100,43000,2),
     *          itab(179,361)
      real*8    gff(43000),gfl(43000)
      real*4    gmod(100,43000,2)
      common/modcu/ nlayers,npoints,gff,gfl,gmod,mnn,itab,mind
c --- Type definitions -------
      integer*4 i,j,ia,lle,llb,lln,l
      integer*4 isolid(50),linmax(50),linmin(50),ilab(50),ilae(50)
c  upmin,upmax,lowmin,lowmax
      real*4    uplow(50,4)
      do j=1,nlayers
        linmax(j)=0
        linmin(j)=1000
        uplow(j,1)=1.0e6
        uplow(j,3)=1.0e6
        uplow(j,2)=-1.0e6
        uplow(j,4)=-1.0e6
        isolid(j)=0
      enddo
      do i =1,npoints
        ia=1
        do j=1,nlayers
          llb=ia
          lln=0
    1     ia=ia+1
          lln=lln+1
          if(mind(ia,i,2).gt.0) goto 1
          lle=ia
          lln=lln+1
          ia=ia+1
          if(i.eq.1) then
            ilab(j)=llb
            ilae(j)=lle
          endif
          if(lln.gt.linmax(j)) linmax(j)=lln
          if(lln.lt.linmin(j)) linmin(j)=lln
          if(gmod(llb,i,1).gt.uplow(j,2)) uplow(j,2)=gmod(llb,i,1)
          if(gmod(llb,i,1).lt.uplow(j,1)) uplow(j,1)=gmod(llb,i,1)
          if(gmod(lle,i,1).gt.uplow(j,4)) uplow(j,4)=gmod(lle,i,1)
          if(gmod(lle,i,1).lt.uplow(j,3)) uplow(j,3)=gmod(lle,i,1)
        enddo
      enddo
      do j=1,nlayers
        if(linmin(j).ne.linmax(j)) then
          write(*,1000) j
          do i=1,nlayers
            write(*,'(i3,4f10.4,2i4)') 
     *           i,(uplow(i,l),l=1,4),linmin(i),linmax(i)
          enddo
          stop
        endif
      enddo
      return
 1000 format('(E005) Different knots number in layer',i3)
      end
c     do j=1,nlayers
c Number of layers equals 2 =======================
c       if(linmin(j).eq.linmax(j).and.linmax(j).eq.2) then
c          isolid(j)=1
c          goto 2
c       endif
c       if(linmin(j).ne.linmax(j)) goto 2
c       if(abs(uplow(j,1)-uplow(j,2)).gt.1.0e-5) goto 2
c       if(abs(uplow(j,3)-uplow(j,4)).gt.1.0e-5) goto 2
c       do i =1,npoints
c          ic=0
c          ia=1
c   3      if(mind(ia,i,2).lt.0) ic=ic+1
c          ia=ia+1
c          if(ic.ne.j) goto 3
c          ia=ia-1
c          ia1=ilae(j)
c   4      if(abs(gmod(ia,i,1)-gmod(ia1,1,1)).gt.1.0e-5) then
c           write(*,*) ia,ia1,i,gmod(ia,i,1),gmod(ia1,1,1) 
c             goto 2
c          endif
c          ia=ia-1
c          ia1=ia1-1
c          if(ia1.ne.ilab(j)) goto 4
c       enddo
c       isolid(j)=1
c   2   continue
c     enddo
c     do j=1,nlayers
c      write(*,'(4f13.6,5i5)') (uplow(j,l),l=1,4),linmin(j),linmax(j),isolid(j),ilab(j),ilae(j)
c     enddo
c     stop
c     return
c     end
