c============================================================
c Reading auxilary data from tmp.2 file
c============================================================
      subroutine read_dep(i_dev,i_g,tmp2,t_min,r_max)
      implicit none
c ---
      real*8    geo,r0,pi,rad,hsu(10),hs(10)
      integer*4 nhs,max_delta
      common/const/geo,r0,pi,rad,hsu,hs,nhs,max_delta
c ---
      character*160 tmp2
      real*8     t_min(100,11,3),r_max(100,11,3)
      integer*4 ih,ic,ic_old,i1,i2,i,istep,i_g,i_dev,jj,ih_old
      real*8    h,hm,t,t_old,tm,raym,raym_old,dist,dist_old,rm
      real*8    h_old,tim0,del0
c ---
      open(i_dev,file=tmp2,status='old',form='formatted')
      ic_old=-1
      h_old=-1.0d0
      ih_old=-1
      del0=-1.0d0
      tim0=-1.0d0
    1 read(i_dev,*,end=9) h,ic,t,dist,raym
      if(ic.lt.100) then
         if(ic.lt.i_g) goto 1
      else
         ic=ic-100
      endif
      ih=h/10.0d0+2.5d0
       do jj=2,nhs
          if(dabs(hs(jj)-h).lt.0.01d0) then
             ih=jj+1
             goto 8
          endif
        enddo
    8 if(ic.ne.ic_old.or.ih.ne.ih_old) goto 2
    3 i1=dist_old/25.0d0
      i2=dist/25.0d0
      istep=1
      if(i1.gt.i2) istep=-1
      do i=i1,i2,istep
      if(i.gt.max_delta) goto 4
        hm=dble(i)*25.0d0
        if((dist_old.le.hm.and.hm.le.dist).or.
     *     (dist.le.hm.and.hm.le.dist_old)) then
          if(dabs(dist-dist_old).lt.1.0d-8) then
           tm=(t+t_old)/2.0d0
           rm=(raym+raym_old)/2.0d0
          else
           tm=(t-t_old)*(hm-dist_old)/(dist-dist_old)+t_old
           rm=(raym-raym_old)*(hm-dist_old)/(dist-dist_old)+raym_old
          endif
          if(dabs(t_min(i+1,ih,i_g)).gt.tm) then
              t_min(i+1,ih,i_g)=tm
              r_max(i+1,ih,i_g)=rm
          endif
        endif
   4  continue
      enddo
   2  t_old=t
      h_old=h
      ih_old=ih
      ic_old=ic
      dist_old=dist
      raym_old=raym
      goto 1
    9 close(i_dev)
      return
      end
