c*********************************************************************
c
c     Subroutine seis88 is a main module for ray tracing
c     Forms final SSSC's and stores in external flat file
c
c*********************************************************************
      subroutine seis88(i_n,take_off)
      implicit none
c ---
      integer*4 n_int,n_intz,n_lay
      parameter (n_int=20,n_intz=50,n_lay=19)
c ---
      real*8    vel(6),y(4),take_off(20),v1,v2,vinit,xsss
      real*8    a2,ac,amax1,amax2,amin1,amin2,astep1,astep2,au,ba,
     *bb,bl,br,ddm,dt,rmin,tmax,tsour,x2,xsour,zint,zsour
      integer*4 i,i_n,ibp,ibs,ic1,ic2,icont,idp,ids,ifin,
     *iloc,iread,irec,isour,itmax,itpr,iup,ius,j,jj,k_i,ldum,ldum1,
     *ldum2,lin,lou,lu1,lu2,ltape,mdim,mep,method,mm,
     *mode,mout,nawx,nc,ncode,ndr,nl,nlay,nlayer
      integer*4 k_ii,l,k,i_t,l1,l2,l3,l4,lnblnk,kkk,ll,il,i_d
      integer*4 system
      character*68 mtext
      character*160 tmp2
      character*160 f_out,digit,cmd,sfn,suffix
      character*4 phase
      real*8    hsur(101),hsur3(101),hss,slamd,sfi_c
      real*8    tab_cu(12),ray_cu(12),tab_91(11)
c -- commons ---
      real*8    geo,r0,pi,rad,h(10),hs(10)
      integer*4 nhs,max_delta
      common/const/geo,r0,pi,rad,h,hs,nhs,max_delta
c ---
      real*8    sl6(4500),vmoh(4500)
      common/sl/sl6,vmoh
c ---
      real*8    dst,astart,astep,afin,reps,reps1,rstep
      integer*4 ndst,idist
      common/dist/dst(100),ndst,idist,astart,astep,afin,reps,reps1,rstep
c ---
      integer*4 code,kref,kc,k_beg,k_end,k_step,k_sig
      common/cod/code(50),kref,kc,k_beg,k_end,k_step,k_sig
c ---
      real*8    a1,b1,c1,d1,x1,brd
      integer*4 iii,npnt,nint
      common/intrf/a1(n_intz,n_int),b1(n_intz,n_int),c1(n_intz,n_int),
     *d1(n_intz,n_int),x1(n_intz,n_int),brd(2),iii(n_intz,n_int),
     *npnt(n_int),nint
c ---
      real*8    ay,ds
      integer*4 kint,mreg,n,iref,ind,ind1
      common/ray/ay(12,10000),ds(11,50),kint(50),mreg,n,iref,ind,ind1
c ---
      integer*4 intr,int1,iout,kre,irefr,lay,itype,nder,iprint,mprint,ntr,imet
      common/auxi/intr,int1,iout,kre,irefr,lay,itype,nder,iprint,mprint,ntr,imet
c ---
      integer*4 nrho
      real*8    rho1,rho2
      common/den/rho1(n_lay),rho2(n_lay),nrho
c ---
      real*8    ros,vps,vss
      common/sour/ros,vps,vss
c ---
      integer*4 ksh,nsh
      common/sh/ksh,nsh
c ---
      integer*4 icod,ivsp
      real*8    xvsp
      common/vsp/xvsp,icod,ivsp
c ---
      integer*4 i_g,i_gg
      real*8    t_min,t_min3,r_max
      common/tbl/i_g,i_gg,t_min(100,11,3),t_min3(100,3),r_max(100,11,3)
c ---
      integer*4 idbg,iaz_i,iaz_e,iaz_st,iaz_c,igraph,igrc,igeoc,npid
      real*8    azi,sfi,slam,elev
      character*8 sta_name,surr_name,tables
      character*8 spid
      common/all/azi,sfi,slam,elev,spid,idbg,iaz_i,iaz_e,iaz_st,iaz_c,
     *sta_name,surr_name,tables,igraph,igrc,igeoc,npid
c ---
      integer*4   nlayers,net,iwave,igroup(100)
      integer*4   nng,ngrno(100),ngrdev(100)
      real*8      st_rk,dnet
      character*8 p_phname(100),s_phname(100),name(100)
      character*1 c_wave(100),c_head(100)
      common/prm/st_rk,dnet,nlayers,iwave,net,
     *nng,ngrno,ngrdev,name,
     *igroup,p_phname,s_phname,c_wave,c_head
c --- Type definition
      character*80 fili,filo
      real*4 dtime, delta, tarray(2)
c
      delta = dtime ( tarray )
c
      mode=1
      call iasp91_read
      fili='tmp.'//spid(1:npid)//'.seis.data'
      filo='tmp.'//spid(1:npid)//'.se.out'
      lin=7
      lou=8
      open(lin,file=fili,form='formatted',status='old')
      open(lou,file=filo,form='formatted',status='unknown')

c
    1 read(lin,110)ldum1,ldum2,mprint,mtext,ldum,mm
      write(lou,110)ldum1,ldum2,mprint,mtext,ldum,mm
c
c     Specification of the model
c
      call model(lin,lou,mm,mtext)
      if(mm.lt.0)ind=19
      if(mm.lt.0)write(lou,112)ind
      if(mm.lt.0)go to 99
c
c     Specification of the synthetic seismograms
c
    2 read(lin,100)icont,mep,mout,mdim,method,ibp,ibs,iup,ius,idp,ids,
     1iread,mreg,itmax,nlay,lu1,lu2,ltape,ksh,iloc
      if(icont.eq.0)go to 99
      write(lou,102)icont,mep,mout,mdim,method,ibp,ibs,iup,ius,idp,ids,
     1iread,mreg,itmax,nlay,lu1,lu2,ltape,ksh,iloc
      if(icont.eq.(-1))go to 1
c
      if(nrho.eq.1)mreg=1
      if(itmax.eq.0)itmax=20
      irec=1
      imet=0
      ivsp=0
      itpr=iloc
      if(itpr.eq.0)itpr=3
      if(itpr.gt.100)irec=itpr-100
      if(iloc.eq.1)ivsp=1
      if(iloc.eq.1)itpr=22
      if(ivsp.eq.1)mreg=1
      if(ivsp.eq.1)irec=0
      if(irec.ne.1)mreg=1
      nlayer=nint-nlay
      ndr=8
      nder=0
      if(mdim.ne.0)nder=1
      if(mdim.ne.0)ndr=11
c
      if(mep.gt.0)go to 3
      ndst=-mep
      read(lin,104)(dst(i),i=1,ndst),xvsp
      write(lou,104)(dst(i),i=1,ndst),xvsp
      if(ndst.eq.1)rstep=1.d0
      if(ndst.eq.1)dst(2)=dst(1)+1.d0
      if(ndst.eq.1)go to 4
      rstep=(dst(ndst)-dst(1))/float(ndst-1)
      go to 4
    3 ndst=mep
      read(lin,104)rmin,rstep,xvsp
      write(lou,104)rmin,rstep,xvsp
      do 13 i=1,mep
   13 dst(i)=rmin+(i-1)*rstep
c
    4 read(lin,104)xsour,zsour,tsour,reps,reps1,brd(1),brd(2)
      write(lou,104)xsour,zsour,tsour,reps,reps1,brd(1),brd(2)
      read(lin,104)dt,amin1,astep1,amax1,amin2,astep2,amax2,ac
      write(lou,104)dt,amin1,astep1,amax1,amin2,astep2,amax2,ac
      if(dt.lt.0.0000001d0)dt=1.d0
      if(ac.lt.0.0000001d0)ac=0.0001d0
      tmax=9999.999d0
      if(reps.lt..00001d0)reps=.05d0
      if(reps1.lt..00001d0)reps1=.05d0*reps
      ind=-1
      nc=npnt(1)
      bl=x1(1,1)
      br=x1(nc,1)
      ba=brd(1)
      bb=brd(2)
      if(dabs(bb-ba).gt..00001d0)go to 5
      brd(1)=bl
      brd(2)=br
    5 if(ba.lt.bl)brd(1)=bl
      if(bb.gt.br)brd(2)=br
      intr=6
      do k=1,4500
        xsss=k-1
  501   nl=npnt(intr)-1
        do 502 i=1,nl
        j=i
        if(xsss.lt.x1(i+1,intr))go to 503
  502   continue
  503   continue
        a2=a1(j,intr)
        x2=x1(j,intr)
        au=(xsss-x2)/(x1(j+1,intr)-x1(j,intr))
        sl6(k)=a1(j,intr)+(6.0d0*au*au-15.0d0*au+10.0d0)*
     x  au*au*au*(a1(j+1,intr)-a1(j,intr))
      enddo
c --- Moho timing -------------------------------------
      lay=6
      int1=6
      itype=isign(1,iwave)
      vinit=0.0d0
      v1=0.0d0
      do k=1,4500
        y(1)=k-1
        y(2)=sl6(k)
        y(3)=0.0d0
        y(4)=0.d0
        call veloc(y,vel)
        v2=1.0d0/vel(1)
        if(k.ne.1) vinit=vinit+(v1+v2)/2.0d0
        vmoh(k)=vinit
        v1=v2
      enddo
c
c Plot interfaces 
c
      phase='P'
      if(iwave.lt.0) phase='S'
      if(igraph.gt.0) call intf_out(iwave)
c Open file for rays
      if(igraph.gt.0) then
        l2=lnblnk(sta_name)
        write(digit,'(i3)') iaz_c
        l3=1
        if(digit(1:1).eq.' ') l3=2
        if(digit(2:2).eq.' ') l3=3
        name(nng+1)='XXX'
        do kkk=1,nng+1
          l4=lnblnk(name(kkk))
          tmp2=name(kkk)(1:l4)
          if(iwave.lt.0.and.kkk.eq.1) tmp2(1:1)='L'
          l1=lnblnk(tmp2)
          f_out='GRAPH/'//sta_name(1:l2)//'.'//tmp2(1:l1)//
     *    '.ray.'//digit(l3:3)//'.xy'
          open(40+kkk,file=f_out,form='formatted',status='unknown')
        enddo
      endif
c
c     Determination of the position of the source in the model
c
      if(xsour.lt.brd(1).or.xsour.gt.brd(2))go to 205
      intr=1
  201 nl=npnt(intr)-1
      do 202 i=1,nl
      j=i
      if(xsour.lt.x1(i+1,intr))go to 203
  202 continue
  203 continue
      a2=a1(j,intr)
      x2=x1(j,intr)
      au=(xsour-x2)/(x1(j+1,intr)-x1(j,intr))
      zint=a1(j,intr)+(6.0d0*au*au-15.0d0*au+10.0d0)*
     xau*au*au*(a1(j+1,intr)-a1(j,intr))
      if(dabs(zsour).gt..0001d0)go to 204
      isour=1
      zsour=zint
      go to 206
  204 if(zsour.lt.zint.and.intr.eq.1)go to 205
      if(zsour.lt.zint)go to 206
      if(dabs(zsour-zint).lt..000001d0.and.intr.eq.nint)go to 206
      if(intr.eq.nint)go to 205
      isour=intr
      intr=intr+1
      go to 201
  205 ind=50
      write(6,112)ind
      go to 99
  206 lay=isour
      int1=isour
      itype=-1
      y(1)=xsour
      y(2)=zsour
      y(3)=amin1
      y(4)=0.d0
      call veloc(y,vel)
      vss=vel(1)
      itype=1
      call veloc(y,vel)
      vps=vel(1)
      ros=rho1(isour)+rho2(isour)*vps
c Surface elevation ==============
      intr=1
      do k=1,max_delta+1
      hss=(k-1)*25.0d0
      do 305 i=1,nl
      j=i
      if(hss.lt.x1(i+1,intr))go to 303
  305 continue
  303 continue
      a2=a1(j,intr)
      x2=x1(j,intr)
      au=(hss-x2)/(x1(j+1,intr)-x1(j,intr))
      hsur(k)=a1(j,intr)+(6.0d0*au*au-15.0d0*au+10.0d0)*
     xau*au*au*(a1(j+1,intr)-a1(j,intr))
      hsur(k)=r0*(1.0d0-dexp(-hsur(k)/r0))
      enddo 
c Third layer ====================
      intr=3
      do k=1,max_delta+1
      hss=(k-1)*25.0d0
      do 405 i=1,nl
      j=i
      if(hss.lt.x1(i+1,intr))go to 403
  405 continue
  403 continue
      a2=a1(j,intr)
      x2=x1(j,intr)
      au=(hss-x2)/(x1(j+1,intr)-x1(j,intr))
      hsur3(k)=a1(j,intr)+(6.0d0*au*au-15.0d0*au+10.0d0)*
     xau*au*au*(a1(j+1,intr)-a1(j,intr))
      hsur3(k)=r0*(1.0d0-dexp(-hsur3(k)/r0))
      enddo 
c
c    Loop for elementary waves
c
      nawx=0
      if(mout.eq.0)write(lou,105)
      do kkk=1,3
        do k_i=1,100
          t_min3(k_i,kkk)=9999.999d0
        do k_ii=1,nhs+1
          t_min(k_i,k_ii,kkk)=9999.999d0
          r_max(k_i,k_ii,kkk)=9999.999d0
        enddo
        enddo
      enddo
c Open tempopary files for right and left sides ========
      do kkk=1,nng+1
        write(suffix,'(i1)') kkk
        cmd='tmp.'//spid(1:npid)//'.'//suffix(1:1)
        open(30+kkk,file=cmd,status='unknown')
      enddo
cxx   cmd='tmp.'//spid(1:npid)//'.1'
cxx   open(24,file=cmd,status='unknown')
cxx   cmd='tmp.'//spid(1:npid)//'.2'
cxx   open(25,file=cmd,status='unknown')
cxx   cmd='tmp.'//spid(1:npid)//'.3'
cxx   open(26,file=cmd,status='unknown')
cxx   cmd='tmp.'//spid(1:npid)//'.4'
cxx   open(27,file=cmd,status='unknown')
   28 read(lin,118) kc,kref,k_beg,k_end,k_step,k_sig
      if(kref.eq.0) goto 49
  118 format(24i3)
      do 29 k_i=k_beg,k_end,k_step
   20 call gener(nawx,isour,irec,k_i,k_sig,ifin,ncode,lou)
      nawx=1
      if(ifin.eq.1)go to 49
      if(mout.ne.0)write(lou,107)
      write(lou,106)ncode,kc,kref,(code(i),i=1,kref)
      icod=0
      if(ivsp.eq.0)go to 35
      do 34 i=1,kref
      icod=kref-i+1
      if(icod.eq.1)go to 34
      ic1=code(icod)
      ic2=code(icod-1)
      if((ic1-ic2).eq.0)go to 35
      if((ic1*ic2).lt.0)go to 35
   34 continue
   35 continue 
      nsh=0
      do 301 i=1,kref
      if(code(i).gt.0)go to 302
  301 continue
      nsh=ksh
  302 continue
      if(ksh.eq.1.and.nsh.eq.0)go to 20
      if(mout.ne.0)write(lou,108)
      if(ifin.eq.(-1))go to 20
c
      astart=amin1
      astep=astep1
      afin=amax1
      if(kc.le.0)astart=amin2
      if(kc.le.0)astep=astep2
      if(kc.le.0)afin=amax2
      call tramp(xsour,zsour,tsour,dt,ac,tmax,itmax,mout,
     1mdim,ncode,lou,method,isour,ltape,itpr,i_n,take_off)
      if(ind.eq.20.or.ind.eq.21)write(lou,111)ind,lay
      if(ind.eq.20.or.ind.eq.21)go to 99
      if(ind.eq.14)write(lou,112)ind
      go to 29
c
c     End of loop for elementary waves
c
   29 continue
      goto 28
   49 do kkk=1,nng+1
        close(30+kkk)
      enddo
      slamd=slam
      if(slamd.gt.180.0d0) slamd=slamd-360.0d0
      sfi_c=sfi
      if(igeoc.eq.1) sfi_c=datan(dtan(rad*sfi)/geo)/rad
c sorting times for deep rays =================================
      do kkk=1,nng
      write(sfn,'(i1)') kkk
      write(suffix,'(i1)') nng+1
      if(kkk.le.nng-1) then
         cmd='cat tmp.'//spid(1:npid)//'.'//sfn(1:1)//' tmp.'//spid(1:npid)//
     *       '.'//suffix(1:1)//' > tmp.'//spid(1:npid)//'.A'
      else
         cmd='/bin/cp tmp.'//spid(1:npid)//'.'//sfn(1:1)//' tmp.'//spid(1:npid)//'.A'
      endif
      i=system(cmd)
      cmd='sort -u +0.0n -1.0 +1.0n -2.0 +7.0n -8.0 tmp.'//spid(1:npid)//'.A'//
     *    ' > tmp.'//spid(1:npid)//'.B'
      i=system(cmd)
      tmp2='tmp.'//spid(1:npid)//'.B'
c     if(kkk.eq.2) stop
      call read_dep(30+nng+1,kkk,tmp2,t_min,r_max)
c output header =================================================
        write(20+kkk,1115) azi,sfi_c,slamd,elev,nhs,max_delta,sta_name,surr_name,name(kkk)
        write(20+kkk,1116) (hs(il),il=1,nhs)
c output body =================================================
      do i=1,max_delta+1 
      do 67 i_d=1,nhs+1
        if(i_d.eq.2) goto 67
        if(i.gt.4.and.t_min(i,i_d,kkk).gt.9998.999d0.and.t_min(i-1,i_d,kkk).lt.9998.999d0) then
          do i_t=i+1,max_delta+1
            if(t_min(i_t,i_d,kkk).lt.9998.999d0) then
              if(i_t -i.gt.12) goto 66
              do jj=i,i_t-1
                t_min(jj,i_d,kkk)=-((dabs(t_min(i_t,i_d,kkk))-dabs(t_min(i-1,i_d,kkk)))/
     *                     (i_t-i+1)*(jj-i+1)+dabs(t_min(i-1,i_d,kkk)))
cxx             t_min3(jj,kkk)=-((dabs(t_min3(i_t,kkk))-dabs(t_min3(i-1,kkk)))/
cxx  *                     (i_t-i+1)*(jj-i+1)+dabs(t_min3(i-1,kkk)))
                r_max(jj,i_d,kkk)=(r_max(i_t,i_d,kkk)-r_max(i-1,i_d,kkk))/
     *                     (i_t-i+1)*(jj-i+1)+r_max(i-1,i_d,kkk)
              enddo
              goto 66
            endif
          enddo
   66   continue
        endif
   67   continue
        ddm=(i-1)*25.0d0
cxx     i_tab=3*(1-iwave)/2+kkk
c get iasp91 values =======================
        call iasp91_get(ddm,name(kkk),tab_91)
c get CU values ====     ===================
        tab_cu(1)=ddm
        tab_cu(2)=dabs(t_min(i,1,kkk))
        ray_cu(2)=r_max(i,1,kkk)
        tab_cu(3)=dabs(t_min3(i,kkk))
        ray_cu(3)=r_max(i,1,kkk)
        do l=3,nhs+1
          tab_cu(l+1)=dabs(t_min(i,l,kkk))
          ray_cu(l+1)=r_max(i,l,kkk)
        enddo
c clean the first line ======================
        if(i.eq.0) then
          do l=2,nhs+2
            ray_cu(l)=0.0d0
          enddo
        endif
c mask CU values by iasp91 values ===================
        do l=1,nhs+1
          ll=l
          if(l.eq.1) ll=2
          if(tab_91(ll).gt.9998.000d0) then
            tab_cu(l+1)=9999.999d0
            ray_cu(l+1)=9999.999d0
          endif
          if(tab_91(ll).lt.9998.000d0.and.tab_cu(l+1).lt.9998.000d0) 
     *    tab_cu(l+1)=dabs(tab_cu(l+1))-tab_91(ll)
        enddo
c output SSSCs =====================
cxx     write(20+kkk,1116) ddm,hsur(i),hsur3(i),dabs(t_min(i,1,kkk)),
cxx  *  dabs(r_max(i,1,kkk)),dabs(t_min3(i,kkk)),dabs(r_max(i,1,kkk)),
cxx  *  (dabs(t_min(i,l,kkk)),dabs(r_max(i,l,kkk)),l=3,7)
        write(20+kkk,1116) tab_cu(1),hsur(i),tab_cu(2),ray_cu(2),
     *  (tab_cu(l),ray_cu(l),l=4,nhs+2)
      enddo
      enddo
 1115 format(4f12.5,2i5,1x,a8,1x,a8,1x,a8)
 1116 format(f7.1,25f9.3)
c
      go to 2
c
  100 format(26i3)
  102 format(1h1,////,2x,26i3)
  104 format(8f10.5)
  105 format(//2x,'Listing of wave codes'//2x,'int.code',5x,'e x t e r n
     1 a l   c o d e')
  106 format(i10,5x,31i3/18x,30i3)
  107 format(//2x,'int.code',5x,'e x t e r n a l   c o d e')
  108 format(//)
  110 format(3i2,a68,2x,2i2)
  111 format(/2x,'ind=',i5,2x,'lay=',i5/)
  112 format(/2x,'ind=',i5/)
c
c     ***
   99 continue
c     ***
c
      close(lin)
      close(lou)
      delta = dtime ( tarray )
      write(*,'("(I667) Time=",f7.3," Azi=",f6.1)') delta,azi
      return
      end
